poj/OpenJ_Bailian - 2528 离散化+线段树

传送门:http://bailian.openjudge.cn/practice/2528?lang=en_US

//http://poj.org/problem?id=2528

题意:

给你n长海报,每张海报在墙上贴的区间范围是l,r

问你这n张海报贴完后,可以看见的海报数量是多少

题解:

离散化+线段树

因为l,r的数据范围是1e7,而题目只给了64MB的空间,直接存的话空间会炸掉,所以需用用到离散化的技巧

然后按照端点单点更新即可

现在重新写这题发现这个题坑点在于每一个点他都代表一个长度为1的东东,所以我们普通的离散话会出问题

1-10 1-4 5-10
1-10 1-4 6-10

譬如 如上这组例子

所以我们离散化时做一下优化, 如果相邻间数字间距大于1时我们就在其中加上任意一个数字

这样离散话下来后做线段树就可以过
这组数据
3
5 6
4 5
6 8
3
1 10
1 3
6 10
5
1 4
2 6
8 10
3 4
7 10

这组数据

答案是3,3,4

代码:

#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>
#include <bitset>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef pair<LL, LL> pLL;
typedef pair<LL, int> pLi;
typedef pair<int, LL> pil;;
typedef pair<int, int> pii;
typedef unsigned long long uLL;
#define ls rt<<1
#define rs rt<<1|1
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define bug printf("*********\n")
#define FIN freopen("input.txt","r",stdin);
#define FON freopen("output.txt","w+",stdout);
#define IO ios::sync_with_stdio(false),cin.tie(0)
#define debug1(x) cout<<"["<<#x<<" "<<(x)<<"]\n"
#define debug2(x,y) cout<<"["<<#x<<" "<<(x)<<" "<<#y<<" "<<(y)<<"]\n"

const double eps = 1e-8;
const int mod = 1e9 + 7;
const int maxn = 3e5 + 5;
const int INF = 0x3f3f3f3f;
const LL INFLL = 0x3f3f3f3f3f3f3f3;
struct node {
    int l, r;
} q[maxn];
int col[maxn];
int vis[maxn];
int ans;
void push_down(int rt) {
    if(col[rt] != -1) {
        col[ls] = col[rs] = col[rt];
        col[rt] = -1;
    }
    return;
}
void update(int L, int R, int c, int l, int r, int rt) {
    if(L <= l && r <= R) {
        col[rt] = c;
        return;
    }
    push_down(rt);
    int mid = (l + r) >> 1;
    if(L <= mid) update(L, R, c, lson);
    if(R > mid) update(L, R, c, rson);
}
void query(int l, int r, int rt) {
    if(col[rt] != -1) {
        if(!vis[col[rt]]) ans++;
        vis[col[rt]] = true;
        return;
    }
    if(l == r) return;
    int mid = (l + r) >> 1;
    query(lson);
    query(rson);
}
int x[maxn];
int main() {
    int T;
    scanf("%d", &T);
    while(T--) {
        int cnt = 0;
        int n;
        scanf("%d", &n);
        for(int i = 0; i < n; i++) {
            scanf("%d%d", &q[i].l, &q[i].r);
            x[cnt++] = q[i].l;
            x[cnt++] = q[i].r;
        }
        sort(x, x + cnt);
        int m = 1;
        for(int i = 1; i < cnt; i++) {
            if(x[i] != x[i - 1]) {
                x[m++] = x[i];
            }
        }
        for(int i = m - 1; i >= 1; i--) {
            if(x[i] != x[i - 1] + 1) {
                x[m++] = x[i - 1] + 1;
            }
        }
        sort(x, x + m);
        memset(col, -1, sizeof(col));
        for(int i = 0; i < n; i++) {
            int l = lower_bound(x, x + m, q[i].l) - x;
            int r = lower_bound(x, x + m, q[i].r) - x;
            update(l, r, i, 0, m, 1);
        }
        ans = 0;
        memset(vis, false, sizeof(vis));query(0, m, 1);
        printf("%d\n",ans );

    }
}

原文地址:https://www.cnblogs.com/buerdepepeqi/p/10864798.html

时间: 2024-08-01 20:38:02

poj/OpenJ_Bailian - 2528 离散化+线段树的相关文章

poj 2528 离散化+线段树

这个破题  我WA 了   我实在找不到我那里错了 题意:有一个墙,往墙上贴报纸,最后问能看到几张报纸 其实就是很容易的线段树,不容易的地方在于离散化 离散化要保存所有需要用到的值,排序后,分别映射到1~n,这样复杂度就会小很多很多这题的难点在于每个数字其实表示的是一个单位长度(并且一个点),这样普通的离散化会造成许多错误(包括我以前的代码,这题数据奇弱) 出下面两个简单的例子应该能体现普通离散化的缺陷: 1-10 1-4 5-10 1-10 1-4 6-10  为了解决这种缺陷,我们可以在排序

hdu 2528(离散化线段树)

题目链接:http://poj.org/problem?id=2528 Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 43201   Accepted: 12591 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing

poj 2528 Mayor&#39;s posters【离散化+线段树】

题目:poj 2528 Mayor's posters 题意:给一个长度非常长的墙上贴长度为ai的海报,由于有的会覆盖掉,求最后能看见的海报个数. 分析:题目和POJ2777 一模一样,方法也一样,只不过这个要离散化,其次要数组开大一点.至少2倍. 离散化的时候用了C++的 pair 类,还是比较好用的. 代码: #include <iostream> #include <algorithm> #include <utility> #include <cstrin

POJ 2528 Mayor&#39;s posters(离散化线段树)

Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for

POJ 2528 Mayor&amp;#39;s posters 离散化+线段树

题目大意:给出一些海报和贴在墙上的区间.问这些海报依照顺序贴完之后,最后能后看到多少种海报. 思路:区间的范围太大,然而最多仅仅会有10000张海报,所以要离散化. 之后用线段树随便搞搞就能过. 关键是离散化的方法,这个题我时隔半年才A掉,之前一直就TTT,我还以为是线段树写挂了. 当我觉得我自己的水平这样的水线段树已经基本写不挂的时候又写了这个题,竟然还是T. 后来我对照别人的代码,才发现是我的离散化写渣了. 以下附AC代码(79ms),这个离散化写的比較优雅.时间也非常快,以后就这么写了.

POJ 2528 Mayor&#39;s posters (离散化 + 线段树)

强烈不推荐在POJ做这道题!!! 强烈不推荐在POJ做这道题!!! 强烈不推荐在POJ做这道题!!! 推荐去UVA 10587 或 SCU 2249 POJ的数据比较水且可能有错,一些本来错误的数据但可以水过,以及在UVA与SCU同样题目都能AC的程序在POJ莫名WA了. 建议写完程序后跑下这组数据: 1 3 1 10 1 3 6 10 好多题解的答案是2,但答案明显是3,这是因为每个数字其实表示的是一个单位长度,并非一个点 , 这就会导致像这样的区间: 1-10 1-4 5-10 1-10 1

【POJ】2528 Mayor&#39;s posters ——离散化+线段树

Mayor's posters Time Limit: 1000MS    Memory Limit: 65536K Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city

POJ 2528 Mayor&#39;s posters(离散化 线段树)

题意  在墙上贴n张海报  输入每张海报的的左右端点坐标  问最后可以看到多少张海报  能看到一点也是能看到 先把线段树初始化为0 输入一张海报  就把那个区间变成这张海报的序号  最后判断墙上有多少个不同的序号就行了 但是海报坐标的端点值高达10000000  直接用线段树会超时   但是注意到海报最多只有10000张  也就是最多有20000个不同的坐标  于是可以利用离散化的知识   把所有坐标排序 注意所有右端点坐标+1也要加入排序(注意1,10 ; 1,3;  7,10这种情况  如果

POJ 2528 Mayor&#39;s posters 区间离散化线段树

点击打开链接 Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 45894   Accepted: 13290 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their elector